<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>DataNodeV1.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.upgrade</a> &gt; <span class="el_source">DataNodeV1.java</span></div><h1>DataNodeV1.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.upgrade;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

import org.apache.jute.Index;
import org.apache.jute.InputArchive;
import org.apache.jute.OutputArchive;
import org.apache.jute.Record;
import org.apache.zookeeper.data.ACL;
import org.apache.zookeeper.data.Stat;
import org.apache.zookeeper.data.StatPersistedV1;

/**
 * This class contains the data for a node in the data tree.
 * &lt;p&gt;
 * A data node contains a reference to its parent, a byte array as its data, an
 * array of ACLs, a stat object, and a set of its children's paths.
 * 
 */
public class DataNodeV1 implements Record {
<span class="fc" id="L42">    DataNodeV1() {</span>
        // default rather than public constructor
<span class="fc" id="L44">    }</span>

<span class="fc" id="L46">    DataNodeV1(DataNodeV1 parent, byte data[], List&lt;ACL&gt; acl, StatPersistedV1 stat) {</span>
<span class="fc" id="L47">        this.parent = parent;</span>
<span class="fc" id="L48">        this.data = data;</span>
<span class="fc" id="L49">        this.acl = acl;</span>
<span class="fc" id="L50">        this.stat = stat;</span>
<span class="fc" id="L51">        this.children = new HashSet&lt;String&gt;();</span>
<span class="fc" id="L52">    }</span>
    

    /**
     * convenience method for creating DataNode
     * fully
     * @param children
     */
    public void setChildren(HashSet&lt;String&gt; children) {
<span class="nc" id="L61">        this.children = children;</span>
<span class="nc" id="L62">    }</span>
    
    /**
     * convenience methods to get the children
     * @return the children of this datanode
     */
    public HashSet&lt;String&gt; getChildren() {
<span class="nc" id="L69">        return this.children;</span>
    }
    
    DataNodeV1 parent;

    byte data[];

    List&lt;ACL&gt; acl;

    public StatPersistedV1 stat;

<span class="fc" id="L80">    HashSet&lt;String&gt; children = new HashSet&lt;String&gt;();</span>

    public void copyStat(Stat to) {
<span class="nc" id="L83">        to.setAversion(stat.getAversion());</span>
<span class="nc" id="L84">        to.setCtime(stat.getCtime());</span>
<span class="nc" id="L85">        to.setCversion(stat.getCversion());</span>
<span class="nc" id="L86">        to.setCzxid(stat.getCzxid());</span>
<span class="nc" id="L87">        to.setMtime(stat.getMtime());</span>
<span class="nc" id="L88">        to.setMzxid(stat.getMzxid());</span>
<span class="nc" id="L89">        to.setVersion(stat.getVersion());</span>
<span class="nc" id="L90">        to.setEphemeralOwner(stat.getEphemeralOwner());</span>
<span class="nc" id="L91">        to.setDataLength(data.length);</span>
<span class="nc" id="L92">        to.setNumChildren(children.size());</span>
<span class="nc" id="L93">    }</span>

    public void deserialize(InputArchive archive, String tag)
            throws IOException {
<span class="fc" id="L97">        archive.startRecord(&quot;node&quot;);</span>
<span class="fc" id="L98">        data = archive.readBuffer(&quot;data&quot;);</span>
<span class="fc" id="L99">        Index i = archive.startVector(&quot;acl&quot;);</span>
<span class="fc bfc" id="L100" title="All 2 branches covered.">        if (i != null) {</span>
<span class="fc" id="L101">            acl = new ArrayList&lt;ACL&gt;();</span>
<span class="fc bfc" id="L102" title="All 2 branches covered.">            while (!i.done()) {</span>
<span class="fc" id="L103">                ACL a = new ACL();</span>
<span class="fc" id="L104">                a.deserialize(archive, &quot;aclEntry&quot;);</span>
<span class="fc" id="L105">                acl.add(a);</span>
<span class="fc" id="L106">                i.incr();</span>
<span class="fc" id="L107">            }</span>
        }
<span class="fc" id="L109">        archive.endVector(&quot;acl&quot;);</span>
<span class="fc" id="L110">        stat = new StatPersistedV1();</span>
<span class="fc" id="L111">        stat.deserialize(archive, &quot;stat&quot;);</span>
<span class="fc" id="L112">        archive.endRecord(&quot;node&quot;);</span>
<span class="fc" id="L113">    }</span>

    synchronized public void serialize(OutputArchive archive, String tag)
            throws IOException {
<span class="nc" id="L117">        archive.startRecord(this, &quot;node&quot;);</span>
<span class="nc" id="L118">        archive.writeBuffer(data, &quot;data&quot;);</span>
<span class="nc" id="L119">        archive.startVector(acl, &quot;acl&quot;);</span>
<span class="nc bnc" id="L120" title="All 2 branches missed.">        if (acl != null) {</span>
<span class="nc bnc" id="L121" title="All 2 branches missed.">            for (ACL a : acl) {</span>
<span class="nc" id="L122">                a.serialize(archive, &quot;aclEntry&quot;);</span>
<span class="nc" id="L123">            }</span>
        }
<span class="nc" id="L125">        archive.endVector(acl, &quot;acl&quot;);</span>
<span class="nc" id="L126">        stat.serialize(archive, &quot;stat&quot;);</span>
<span class="nc" id="L127">        archive.endRecord(this, &quot;node&quot;);</span>
<span class="nc" id="L128">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>